#define APPNAME "TestApp"

#define WIN32_LEAN_AND_MEAN
// Windows Header Files:
#include <windows.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>

// Local Header Files
#include "JEmpower.h"

#include "TestPanel.hpp"
#include "cafjava_awt_event_MouseMotionListener.hpp"

class MyMouseMotionListener : public cafjava_awt_event_MouseMotionListener {
public:
        virtual void mouseMoved(JNIEnv *_env, java_awt_event_MouseEvent &arg0)
        {
                int i = 1;
                int j = 2;
                i = i + j;
        }
        virtual void mouseDragged(JNIEnv *_env, java_awt_event_MouseEvent &arg0)
        {
                int i = 1;
                int j = 2;
                i = i + j;

        }

};



// Global Variables:

char szAppName[] = APPNAME; // The name of this application
char szTitle[]   = APPNAME": Sample Application"; // The title bar text

// Foward declarations of functions included in this code module:


ATOM MyRegisterClass(CONST WNDCLASS*);
BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);



//
//  FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)
//
//  PURPOSE: Entry point for the application.
//
//  COMMENTS:
//
//      This function initializes the application and processes the
//      message loop.
//
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
        MSG msg;
        HANDLE hAccelTable;

        if (!hPrevInstance) {
                // Perform instance initialization:
                if (!InitApplication(hInstance)) {
                        return (FALSE);
                }
        }

        jeInitJavaRuntime();

        // Perform application initialization:
        if (!InitInstance(hInstance, nCmdShow)) {
                return (FALSE);
        }

        hAccelTable = LoadAccelerators (hInstance, szAppName);

        // Main message loop:
        while (GetMessage(&msg, NULL, 0, 0)) {
                if (!TranslateAccelerator (msg.hwnd, hAccelTable, &msg)) {
                        TranslateMessage(&msg);
                        DispatchMessage(&msg);
                }
        }

        return (msg.wParam);

        lpCmdLine; // This will prevent 'unused formal parameter' warnings
}



//
//  FUNCTION: InitApplication(HANDLE)
//
//  PURPOSE: Initializes window data and registers window class
//
//  COMMENTS:
//
//       In this function, we initialize a window class by filling out a data
//       structure of type WNDCLASS and calling either RegisterClass or
//       the internal MyRegisterClass.
//
BOOL InitApplication(HINSTANCE hInstance)
{
        WNDCLASS  wc;
        HWND      hwnd;

        // Win32 will always set hPrevInstance to NULL, so lets check
        // things a little closer. This is because we only want a single
        // version of this app to run at a time
        hwnd = FindWindow (szAppName, NULL);
        if (hwnd) {
                // We found another version of ourself. Lets defer to it:
                if (IsIconic(hwnd)) {
                        ShowWindow(hwnd, SW_RESTORE);
                }
                SetForegroundWindow (hwnd);

                // If this app actually had any functionality, we would
                // also want to communicate any action that our 'twin'
                // should now perform based on how the user tried to
                // execute us.
                return FALSE;
        }

        // Fill in window class structure with parameters that describe
        // the main window.
        wc.style         = CS_HREDRAW | CS_VREDRAW;
        wc.lpfnWndProc   = (WNDPROC)WndProc;
        wc.cbClsExtra    = 0;
        wc.cbWndExtra    = 0;
        wc.hInstance     = hInstance;
        wc.hIcon         = LoadIcon (hInstance, szAppName);
        wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);

        wc.lpszMenuName  = szAppName;
        wc.lpszClassName = szAppName;

        // Register the window class and return success/failure code.
        return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
        HWND hWnd;

        hWnd = CreateWindow(szAppName, szTitle, WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                                                          CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                                                          NULL, NULL, hInstance, NULL);

        if (!hWnd) {
                return (FALSE);
        }

        ShowWindow(hWnd, nCmdShow);
        UpdateWindow(hWnd);

        return (TRUE);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  MESSAGES:
//
//      WM_COMMAND - process the application menu
//      WM_PAINT - Paint the main window
//      WM_DESTROY - post a quit message and return
//    WM_DISPLAYCHANGE - message sent to Plug & Play systems when the display changes
//    WM_RBUTTONDOWN - Right mouse click -- put up context menu here if appropriate
//    WM_NCRBUTTONUP - User has clicked the right button on the application's system menu
//
//
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
        PAINTSTRUCT ps;
        HDC hdc;

        switch (message) {
                case WM_CREATE:
                        {
                        /*
                         * Window initialization is performed here in WM_CREATE processing
                         * WinLoadString loads strings from the resource file.
                         */
                        JEBEANHND bean;
                        jeBeanInstantiate(&bean, "TestPanel");

                        jeBeanEmbed(hwnd, bean);
                        HWND bHwnd = jeHWNDFromHandle(bean);
                        SetWindowPos(bHwnd, HWND_TOP, 0, 0, 150,150, SWP_SHOWWINDOW);

                        TestPanel tp(jeObjectFromBean(bean), JObject::globalRef);
                        MyMouseMotionListener *myml = new MyMouseMotionListener();
								java_awt_event_MouseMotionListener ml(myml->getObject());
                        tp.addMouseMotionListener(ml);
                        }
                        break;


                case WM_ERASEBKGND:
                        /*
                         * Return TRUE to request PM to paint the window background
                         * in SYSCLR_WINDOW.
                         */
                        return TRUE;

                case WM_PAINT:
                        hdc = BeginPaint (hwnd, &ps);
                        FillRect(hdc, &ps.rcPaint, GetStockObject(WHITE_BRUSH));
                        EndPaint (hwnd, &ps);
                        break;

                case WM_DESTROY:
                        PostQuitMessage(0);
                        break;

                default:
                        /*
                         * Everything else comes here.  This call MUST exist
                         * in your window procedure.
                         */

                        return DefWindowProc( hwnd, message, wParam, lParam);
        }
        return 0;
}
