#define INCL_PM

#include <os2.h>                        /* PM header file               */
#include "testapp.h"
#include "..\JEmpower\JEmpower.h"

/**************************************************************************
 *
 *  Name       : MyWindowProc
 *
 *  Description: The window procedure associated with the client area in
 *               the standard frame window. It processes all messages
 *               either sent or posted to the client area, depending on
 *               the message command and parameters.
 *
 *  Concepts   :
 *
 *
 *  Parameters :  hwnd = window handle
 *                msg = message code
 *                mp1 = first message parameter
 *                mp2 = second message parameter
 *
 *  Return     :  depends on message sent
 *
 *************************************************************************/
MRESULT EXPENTRY MyWindowProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
  static JEAPPLETHND hApplet=NULLHANDLE;
  HWND hwndApplet=NULLHANDLE;
  static POINTL appletLocn = {0, 0};
  int rc = 0;

  switch( msg ) {
    case WM_CREATE:
      /*
       * Window initialization is performed here in WM_CREATE processing
       * WinLoadString loads strings from the resource file.
       */
      break;

    case WM_COMMAND:
      /*
       * When the user chooses option 1, 2, or 3 from the Options pull-
       * down, the text string is set to 1, 2, or 3, and
       * WinInvalidateRegion sends a WM_PAINT message.
       * When Exit is chosen, the application posts itself a WM_CLOSE
       * message.
       */
      {
        USHORT command;                   /* WM_COMMAND command value     */
        command = SHORT1FROMMP(mp1);      /* Extract the command value    */
        switch (command) {
          case ID_SHOWCONSOLE:
            jeConsoleShow(TRUE);
            break;
          case ID_HIDECONSOLE:
            jeConsoleShow(FALSE);
            break;

          case ID_INITAPPLET:
            {
              SWP swp;
              char *argv[20];

              swp.cx = 150; swp.cy = 150;
#if 0
              setProperty("proxySet", "true");
              setProperty("proxyHost", "proxy.raleigh.ibm.com");
              setProperty("proxyPort", "80");
#endif
#if 0
              argv[0] = "edges=a1-a2,a2-a3,a3-a4,a4-a5,a5-a6,b1-b2,b2-b3,b3-b4,b4-b5,b5-b6,c1-c2,c2-c3,c3-c4,c4-c5,c5-c6,x-a1,x-b1,x-c1,x-a6,x-b6,x-c6";
              hApplet = jeAppletInit(hwnd, "file:////java/demo/GraphLayout/",
                                      "Graph",
                                      swp.cx, swp.cy, 1, argv);
#endif
#if 0
              argv[0] = "text=You Spin Me Right 'Round,Baby";
              argv[1] = "pause=100";
              argv[2] = "x=500";
              argv[3] = "y=500";
              jeAppletInit(&hApplet, 1, hwnd, "http://www.netrex.com/web/Follow.html",
                                      "FollowText.class",
                                      swp.cx, swp.cy, 4, argv);
#endif
#if 0
              argv[0] = "maxwidth=120";
              argv[1] = "nimgs=16";
              argv[2] = "offset=-57";
              argv[3] = "img=images/tumble";
              jeAppletInit(&hApplet, hwnd, hwnd, "file:/java/demo/TumblingDuke/",
                                      "TumbleItem",
                                      swp.cx, swp.cy, 4, argv);
#endif
#if 0
argv[0] = "TITLE=The Latest Weather";
argv[1] = "IMAGESOURCE=images/";
argv[2] = "LABELS=Display data:|Satellite Image|Infrared|Visible|Water Vapor|Surface Reports|Isobars|Isotherms|Frontal Analysis|Radar Summary|Map Boundaries";
argv[3] = "Display data:=LABEL";
argv[4] = "Satellite Image=GROUP|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/satellite/satellite.shtml";
argv[5] = "Infrared=GROUP=Satellite Image|URL=satir.gif|PRELOAD|CALIBRATION=IR|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/satellite/infrared.html";
argv[6] = "Visible=GROUP=Satellite Image|URL=satvis.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/satellite/visible.html";
argv[7] = "Water Vapor=GROUP=Satellite Image|URL=satwv.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/satellite/wvpr.html";
argv[8] = "Surface Reports=URL=sfc.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/obs/obs.shtml|PRELOAD";
argv[9] = "Isobars=URL=isobar.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/contours/isobar.html";
argv[10] = "Isotherms=URL=isotherm.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/contours/isotherm.html";
argv[11] = "Frontal Analysis=URL=front.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/fronts/fronts.shtml";
argv[12] = "Radar Summary=URL=radar.gif|INFO=http://covis.atmos.uiuc.edu/covis/visualizer/help/radar/radar.shtml";
argv[13] = "Map Boundaries=URL=map_nocredit.gif|PRELOAD";
argv[14] = "HELP=AppletHelp.html";
argv[15] = "PROJECTION=US";
argv[16] = "NAVIGATION=projection=Polar Stereographic,scale=0.0807334,xoffset=-240,yoffset=330.34,center_latitude=39.0,center_longitude=-97.0";
argv[17] = "RELOAD_TIMEOUT=11";

              jeAppletInit(&hApplet, hwnd, hwnd, "http://covis1.atmos.uiuc.edu/java/weather0.4/Weather.html",
                                      "Weather04.class",
                                      800, 800, 18, argv);
#endif
#if 0
              argv[0]="codebase=/navigator";
              argv[1] = "coldimg=/alticons/compasscold.gif";
              argv[2] = "hotimg=/alticons/compasshot.gif";
              argv[3] = "target=pages";
              hApplet = jeAppletInit(hwnd, "http://www.gamelan.com/", "Navigator.class",
                                      swp.cx, swp.cy, 4, argv);
#endif
#if 0
              jeAppletInit(&hApplet, 1, hwnd, "file:///F:/java/demo/TicTacToe/Example1.html",
                                      "TicTacToe", swp.cx, swp.cy, 0, 0);
#endif
#if 0
              hApplet = jeAppletInit(hwnd, "file:////java/demo/CardTest/",
                                      "CardTest", swp.cx, swp.cy, 0, 0);
#endif
#if 0
              hApplet = jeAppletInit(hwnd, "file:////java/demo/NervousText/",
                                      "NervousText", swp.cx, swp.cy, 0, 0);
#endif
#if 1
              jeAppletInit(&hApplet, 1, hwnd, "file:///F:/tmp/t/test.html",
                                      "test", swp.cx, swp.cy, 0, 0);
#endif
              hwndApplet = (HWND)jeHWNDFromHandle(hApplet);
              WinSetWindowPos(hwndApplet, HWND_TOP, appletLocn.x, appletLocn.y, 0,0, SWP_ZORDER|SWP_MOVE);
              appletLocn.y += swp.cy + 20;
              WinShowWindow(hwndApplet, TRUE);
#if 0
              {
                MENUITEM mi;
                HWND menuBar = WinWindowFromID(WinQueryWindow(hwnd,QW_PARENT), FID_MENU);
                HWND subMenu = WinCreateWindow(menuBar, WC_MENU, "~Applet",0, 0,0,0,0, menuBar, HWND_TOP, ID_DUMMY, 0, 0);
                mi.iPosition = MIT_END;
                mi.afStyle = MIS_TEXT;
                mi.afAttribute = 0;
                mi.id = ID_DUMMY;
                mi.hwndSubMenu = subMenu;
                mi.hItem = 0;
                WinSendMsg(menuBar,MM_INSERTITEM, &mi, "~Applet");
                addAppletMenu(hApplet, mi.hwndSubMenu, ID_DUMMY + 1);
              }
#endif
              rc = jeAppletStart(hApplet);
            }
            break;
          case ID_STARTAPPLET:
            rc = jeAppletStart(hApplet);
            break;
          case ID_STOPAPPLET:
            rc = jeAppletStop(hApplet);
            break;
          case ID_SHOWTOOLBAR:
            rc = jeAppletToolBarShow(hApplet, TRUE);
            break;
          case ID_HIDETOOLBAR:
            rc = jeAppletToolBarShow(hApplet, FALSE);
            break;
          case ID_DESTROYAPPLET:
            jeAppletDestroy(hApplet);
            {
              MENUITEM mi;
              HWND menuBar = WinWindowFromID(WinQueryWindow(hwnd,QW_PARENT), FID_MENU);
              WinSendMsg(menuBar, MM_QUERYITEM, MPFROM2SHORT(ID_DUMMY, FALSE), &mi);
              WinDestroyWindow(mi.hwndSubMenu);
              WinSendMsg(menuBar, MM_DELETEITEM, MPFROM2SHORT(ID_DUMMY, FALSE), 0);
            }
            break;
          case ID_EXIT:
            WinPostMsg( hwnd, WM_CLOSE, (MPARAM)0, (MPARAM)0 );
            break;
          default:
//            if (SHORT1FROMMP(mp2) == CMDSRC_MENU) {
//              postMenuEvent(hApplet, SHORT1FROMMP(mp1));
//            }
            return WinDefWindowProc( hwnd, msg, mp1, mp2 );
        } /* endswitch */
      } break;

    case WM_MINMAXFRAME:
      {
        PSWP pswp = (PSWP) mp1;
        if (pswp->fl & SWP_MAXIMIZE || pswp->fl & SWP_RESTORE) {
          jeAppletsUniconify(1);
        }
        if (pswp->fl & SWP_MINIMIZE) {
          jeAppletsIconify(1);
        }
      }
      break;

    case WM_SIZE:
//      jeResizeApplet(hApplet, SHORT1FROMMP(mp2), SHORT2FROMMP(mp2));
      break;

    case WM_ERASEBACKGROUND:
      /*
       * Return TRUE to request PM to paint the window background
       * in SYSCLR_WINDOW.
       */
      return (MRESULT)( TRUE );
    case WM_PAINT:
      /*
       * Window contents are drawn here in WM_PAINT processing.
       */
      {
      HPS    hps;                       // Presentation Space handle
      RECTL  rc;                        // Rectangle coordinates
      hps = WinBeginPaint( hwnd, 0L, &rc );
        WinFillRect( hps, &rc, CLR_WHITE);
      WinEndPaint( hps );               // Drawing is complete
      } break;

    case WM_DESTROY:
      jeAppletsDestroy(hwnd);
      break;

    case WM_CLOSE:
      /*
       * This is the place to put your termination routines
       */
      WinPostMsg( hwnd, WM_QUIT, (MPARAM)0,(MPARAM)0 );/* Cause termination*/
      break;

    default:
      /*
       * Everything else comes here.  This call MUST exist
       * in your window procedure.
       */

      return WinDefWindowProc( hwnd, msg, mp1, mp2 );
  }
  return (MRESULT)FALSE;
} /* End of MyWindowProc */

void _System myShowDocument(HWND parent, const char *url, const char *target)
{
//  printf("%x %s %s\n", parent, url, target);
}

/**************************************************************************
 *
 *  Name       : main()
 *
 *  Description: Initializes the process for OS/2 PM services and
 *               process the application message queue until a
 *               WM_QUIT message is received.  It then destroys all
 *               OS/2 PM resources and terminates.
 *
 *  Concepts   : - obtains anchor block handle and creates message
 *                   queue
 *               - creates the main frame window which creates the
 *                   main client window
 *               - polls the message queue via Get/Dispatch Msg loop
 *               - upon exiting the loop, exits
 *
 *  Parameters :  [none]
 *
 *  Return     :  1 - if successful execution completed
 *                0 - if error
 *
 *************************************************************************/
int main(int argc, char *argv[], char *envp[])
{
  HAB  hab;                             // PM anchor block handle
  HMQ  hmq;                             // Message queue handle
  HWND hwndClient = NULLHANDLE;         // Client area window handle
  HWND hwndFrame = NULLHANDLE;          // Frame window handle
  QMSG qmsg;                            // Message from message queue
  ULONG flCreate;                       // Window creation control flags
  ERRORID err;

  if (argc > 1) {
    jeInitJavaRuntimeEx(argc - 1, &argv[1]);
  } else {
    jeInitJavaRuntime();
  }

  jeRegisterShowDocument(myShowDocument);

  hab = WinInitialize(0);               // Initialize PM

  hmq = WinCreateMsgQueue( hab, 0 );    // Create a msg queue

  WinRegisterClass(                     // Register window class
      hab,                              // Anchor block handle
     (PSZ)"MyWindow",                   // Window class name
     (PFNWP)MyWindowProc,               // Address of window procedure
     CS_SIZEREDRAW,                     // Class style
     0                                  // No extra window words
     );

  flCreate = FCF_STANDARD &             // Set frame control flags to
             ~FCF_SHELLPOSITION;        // standard except for shell
                                        // positioning.

  hwndFrame = WinCreateStdWindow(
          HWND_DESKTOP,                 // Desktop window is parent
          0,                            // STD. window styles
          &flCreate,                    // Frame control flag
          "MyWindow",                   // Client window class name
          "",                           // No window text
          0,                            // No special class style
          (HMODULE)0L,                  // Resource is in .EXE file
          ID_WINDOW,                    // Frame window identifier
          &hwndClient                   // Client window handle
          );

  if (hwndFrame) {
    WinSetWindowText(hwndFrame, "JavaEmpowered Sample");

    WinSetWindowPos( hwndFrame,           /* Shows and activates frame    */
                     HWND_TOP,            /* window at position 100, 100, */
                     100, 100, 300, 250,
                     SWP_SIZE | SWP_MOVE | SWP_ACTIVATE | SWP_SHOW
                   );

  /*
   * Get and dispatch messages from the application message queue
   * until WinGetMsg returns FALSE, indicating a WM_QUIT message.
   */

    while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
      WinDispatchMsg( hab, &qmsg );

    WinDestroyWindow(hwndFrame);           /* Tidy up...                   */
    WinDestroyMsgQueue( hmq );             /* Tidy up...                   */
    WinTerminate( hab );                   /* Terminate the application    */
  }
  return TRUE;
} /* End of main */
